///////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2004 Intel Corporation 
// All rights reserved. 
//
// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions are met: 
//
// * Redistributions of source code must retain the above copyright notice, 
// this list of conditions and the following disclaimer. 
// * Redistributions in binary form must reproduce the above copyright notice, 
// this list of conditions and the following disclaimer in the documentation 
// and/or other materials provided with the distribution. 
// * Neither name of Intel Corporation nor the names of its contributors 
// may be used to endorse or promote products derived from this software 
// without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL INTEL OR 
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
// OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
///////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ipp.h"
#include "tools.h"

#include "Image.h"
#include "resize.h"

int main(int argc, char* argv[])
{
	Image8u image;
	if (image.LoadBMP(argv[1]))
		return -1;
	image.View(argv[1],0);
	Image8u bigImage;


	Resize r;
	r.SetInterpType(Resize::LINEAR);
	r.SetFactors(1.5,0.5);
	IppiSize newSize = r.GetDestSize(image.GetSize());

	bigImage.InitAlloc(newSize, image.GetChannelCount());

	r.Go(&image, &bigImage);
	bigImage.View("Big image", 0);

	// Use ROI
	IppiRect roi = {100,100,100,100};
	r.SetSrcROI( roi );
	r.SetFactors(1.5,0.5);
	bigImage.InitAlloc(r.GetDestSize(image.GetSize()),
		image.GetChannelCount());
	r.Go(&image, &bigImage);
	bigImage.View("Big image with source ROI", 0);

	// Create a thumbnail
	r.SetInterpType(Resize::SUPERSAMPLE);
	r.ClearSrcROI();
	r.SetFactors(0.2, 0.2);
	bigImage.InitAlloc(r.GetDestSize(image.GetSize()),
		image.GetChannelCount());
	r.Go(&image, &bigImage);
	bigImage.View("thumbnail", 1);



	return 0;
}
